diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-phy-cca-test.cc ns-3.47/src/wifi/test/wifi-phy-cca-test.cc
--- ns-3.46/src/wifi/test/wifi-phy-cca-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-phy-cca-test.cc	2026-02-16 16:08:49.882231000 -0800
@@ -2987,789 +2993,746 @@
     if (m_channelWidth > 160)
     {
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal below
-        // the energy detection threshold occupies the first 20 MHz subchannel of the S160
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 20 MHz signal that occupies the first subchannel of "
-                            "S160 below ED threshold");
-        ScheduleTest(delay,
-                     {{-65.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{70},
-                       MHz_u{20}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {});
-        delay += Seconds(1.0);
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal below the
+        // energy detection threshold occupies the first 20 MHz subchannel of the S160
+        ScheduleTest(
+            delay,
+            "Reception of a 20 MHz signal that occupies the first subchannel of S160 "
+            "below ED threshold",
+            {{dBm_u{-65}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{70}, MHz_u{20}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {});
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE and CCA-BUSY indication is reported if a signal above the
         // energy detection threshold occupies the first 20 MHz subchannel of the S160.
-        // 36.3.21.6.4: (...) A signal is present on the 20 MHz subchannel at or above a
-        // threshold of –62 dBm. (...)
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 20 MHz signal that occupies the first subchannel of "
-                            "S160 above ED threshold");
-        m_expectedPer20MhzCcaBusyDurations.at(0).at(8) = MicroSeconds(100);
-        ScheduleTest(delay,
-                     {{-61.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{70},
-                       MHz_u{20}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {{MicroSeconds(100) - smallDelta,
-                       MicroSeconds(100),
-                       WIFI_CHANLIST_SECONDARY160,
-                       m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        // 36.3.21.6.4: (...) A signal is present on the 20 MHz subchannel at or above a threshold
+        // of –62 dBm. (...)
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(8) = txDuration1;
+        ScheduleTest(
+            delay,
+            "Reception of a 20 MHz signal that occupies the first subchannel of S160 "
+            "above ED threshold",
+            {{dBm_u{-61}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{70}, MHz_u{20}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
+              WIFI_CHANLIST_SECONDARY160,
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal below
-        // the energy detection threshold occupies the second 20 MHz subchannel of the S80
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 20 MHz signal that occupies the second subchannel of "
-                            "S160 below ED threshold");
-        ScheduleTest(delay,
-                     {{-65.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{50},
-                       MHz_u{20}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {});
-        delay += Seconds(1.0);
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal below the
+        // energy detection threshold occupies the second 20 MHz subchannel of the S80
+        ScheduleTest(
+            delay,
+            "Reception of a 20 MHz signal that occupies the second subchannel of S160 "
+            "below ED threshold",
+            {{dBm_u{-65}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{50}, MHz_u{20}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {});
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE and CCA-BUSY indication is reported if a signal above the
-        // energy detection threshold occupies the second 20 MHz subchannel of the
-        // S160 27.3.20.6.4: 36.3.21.6.4: (...) A signal is present on the 20 MHz subchannel at
-        // or above a threshold of –62 dBm. (...)
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 20 MHz signal that occupies the second subchannel of "
-                            "S160 above ED threshold");
-        m_expectedPer20MhzCcaBusyDurations.at(0).at(9) = MicroSeconds(100);
-        ScheduleTest(delay,
-                     {{-61.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{50},
-                       MHz_u{20}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {{MicroSeconds(100) - smallDelta,
-                       MicroSeconds(100),
-                       WIFI_CHANLIST_SECONDARY160,
-                       m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        // energy detection threshold occupies the second 20 MHz subchannel of the S160 27.3.20.6.4:
+        // 36.3.21.6.4: (...) A signal is present on the 20 MHz subchannel at or above a threshold
+        // of –62 dBm. (...)
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(9) = txDuration1;
+        ScheduleTest(
+            delay,
+            "Reception of a 20 MHz signal that occupies the second subchannel of S160 "
+            "above ED threshold",
+            {{dBm_u{-61}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{50}, MHz_u{20}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
+              WIFI_CHANLIST_SECONDARY160,
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal below
-        // the energy detection threshold occupies the third 20 MHz subchannel of the S80
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 20 MHz signal that occupies the third subchannel of "
-                            "S160 below ED threshold");
-        ScheduleTest(delay,
-                     {{-65.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{30},
-                       MHz_u{20}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {});
-        delay += Seconds(1.0);
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal below the
+        // energy detection threshold occupies the third 20 MHz subchannel of the S80
+        ScheduleTest(
+            delay,
+            "Reception of a 20 MHz signal that occupies the third subchannel of S160 "
+            "below ED threshold",
+            {{dBm_u{-65}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{30}, MHz_u{20}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {});
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE and CCA-BUSY indication is reported if a signal above the
-        // energy detection threshold occupies the third 20 MHz subchannel of the
-        // S160 27.3.20.6.4: 36.3.21.6.4: (...) A signal is present on the 20 MHz subchannel at
-        // or above a threshold of –62 dBm. (...)
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 20 MHz signal that occupies the third subchannel of "
-                            "S160 above ED threshold");
-        m_expectedPer20MhzCcaBusyDurations.at(0).at(10) = MicroSeconds(100);
-        ScheduleTest(delay,
-                     {{-61.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{30},
-                       MHz_u{20}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {{MicroSeconds(100) - smallDelta,
-                       MicroSeconds(100),
-                       WIFI_CHANLIST_SECONDARY160,
-                       m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        // energy detection threshold occupies the third 20 MHz subchannel of the S160 27.3.20.6.4:
+        // 36.3.21.6.4: (...) A signal is present on the 20 MHz subchannel at or above a threshold
+        // of –62 dBm. (...)
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(10) = txDuration1;
+        ScheduleTest(
+            delay,
+            "Reception of a 20 MHz signal that occupies the third subchannel of S160 "
+            "above ED threshold",
+            {{dBm_u{-61}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{30}, MHz_u{20}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
+              WIFI_CHANLIST_SECONDARY160,
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal below
-        // the energy detection threshold occupies the fourth 20 MHz subchannel of the S80
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 20 MHz signal that occupies the fourth subchannel of "
-                            "S160 below ED threshold");
-        ScheduleTest(delay,
-                     {{-65.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{10},
-                       MHz_u{20}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {});
-        delay += Seconds(1.0);
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal below the
+        // energy detection threshold occupies the fourth 20 MHz subchannel of the S80
+        ScheduleTest(
+            delay,
+            "Reception of a 20 MHz signal that occupies the fourth subchannel of S160 "
+            "below ED threshold",
+            {{dBm_u{-65}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{10}, MHz_u{20}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {});
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE and CCA-BUSY indication is reported if a signal above the
-        // energy detection threshold occupies the fourth 20 MHz subchannel of the
-        // S160 27.3.20.6.4: 36.3.21.6.4: (...) A signal is present on the 20 MHz subchannel at
-        // or above a threshold of –62 dBm. (...)
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 20 MHz signal that occupies the fourth subchannel of "
-                            "S160 above ED threshold");
-        m_expectedPer20MhzCcaBusyDurations.at(0).at(11) = MicroSeconds(100);
-        ScheduleTest(delay,
-                     {{-61.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{10},
-                       MHz_u{20}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {{MicroSeconds(100) - smallDelta,
-                       MicroSeconds(100),
-                       WIFI_CHANLIST_SECONDARY160,
-                       m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        // energy detection threshold occupies the fourth 20 MHz subchannel of the S160 27.3.20.6.4:
+        // 36.3.21.6.4: (...) A signal is present on the 20 MHz subchannel at or above a threshold
+        // of –62 dBm. (...)
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(11) = txDuration1;
+        ScheduleTest(
+            delay,
+            "Reception of a 20 MHz signal that occupies the fourth subchannel of S160 "
+            "above ED threshold",
+            {{dBm_u{-61}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{10}, MHz_u{20}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
+              WIFI_CHANLIST_SECONDARY160,
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
-        // occupies the fifth and sixth 20 MHz subchannels of the S160 with received power below
-        // the energy detection threshold for all occupied 20 MHz subchannels
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 40 MHz signal that occupies the fifth and sixth "
-                            "subchannels of S160 below ED threshold");
-        ScheduleTest(delay,
-                     {{-60.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY + MHz_u{20},
-                       MHz_u{40}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {});
-        delay += Seconds(1.0);
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal occupies
+        // the fifth and sixth 20 MHz subchannels of the S160 with received power below the energy
+        // detection threshold for all occupied 20 MHz subchannels
+        ScheduleTest(
+            delay,
+            "Reception of a 40 MHz signal that occupies the fifth and sixth subchannels "
+            "of S160 below ED threshold",
+            {{dBm_u{-60}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{20}, MHz_u{40}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {});
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
-        // occupies the fifth and sixth 20 MHz subchannels of the S160 with received power above
-        // the energy detection threshold for any occupied 20 MHz subchannels
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 40 MHz signal that occupies the fifth and sixth "
-                            "subchannels of S160 above ED threshold");
-        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 12, 2, MicroSeconds(100));
-        ScheduleTest(delay,
-                     {{-58.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY + MHz_u{20},
-                       MHz_u{40}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {{MicroSeconds(100) - smallDelta,
-                       MicroSeconds(100),
-                       WIFI_CHANLIST_SECONDARY160,
-                       m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal occupies
+        // the fifth and sixth 20 MHz subchannels of the S160 with received power above the energy
+        // detection threshold for any occupied 20 MHz subchannels
+        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 12, 2, txDuration1);
+        ScheduleTest(
+            delay,
+            "Reception of a 40 MHz signal that occupies the fifth and sixth subchannels "
+            "of S160 above ED threshold",
+            {{dBm_u{-58}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{20}, MHz_u{40}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
+              WIFI_CHANLIST_SECONDARY160,
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
-        // occupies the seventh and eighth 20 MHz subchannels of the S160 with received power
-        // below the energy detection threshold for all occupied 20 MHz subchannels
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 40 MHz signal that occupies the seventh and eighth "
-                            "subchannels of S160 below ED threshold");
-        ScheduleTest(delay,
-                     {{-60.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY + MHz_u{60},
-                       MHz_u{40}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {});
-        delay += Seconds(1.0);
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal occupies
+        // the seventh and eighth 20 MHz subchannels of the S160 with received power below the
+        // energy detection threshold for all occupied 20 MHz subchannels
+        ScheduleTest(
+            delay,
+            "Reception of a 40 MHz signal that occupies the seventh and eighth "
+            "subchannels of S160 below ED threshold",
+            {{dBm_u{-60}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{60}, MHz_u{40}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {});
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
-        // occupies the seventh and eighth 20 MHz subchannels of the S160 with received power
-        // above the energy detection threshold for any occupied 20 MHz subchannels
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 40 MHz signal that occupies the seventh and eighth "
-                            "subchannels of S160 above ED threshold");
-        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 14, 2, MicroSeconds(100));
-        ScheduleTest(delay,
-                     {{-58.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY + MHz_u{60},
-                       MHz_u{40}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {{MicroSeconds(100) - smallDelta,
-                       MicroSeconds(100),
-                       WIFI_CHANLIST_SECONDARY160,
-                       m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal occupies
+        // the seventh and eighth 20 MHz subchannels of the S160 with received power above the
+        // energy detection threshold for any occupied 20 MHz subchannels
+        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 14, 2, txDuration1);
+        ScheduleTest(
+            delay,
+            "Reception of a 40 MHz signal that occupies the seventh and eighth "
+            "subchannels of S160 above ED threshold",
+            {{dBm_u{-58}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{60}, MHz_u{40}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
+              WIFI_CHANLIST_SECONDARY160,
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
         // occupies the first four 20 MHz subchannels of the S160 with received power below the
         // energy detection threshold for all occupied 20 MHz subchannels
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 80 MHz signal that occupies the first four "
-                            "subchannels of S160 below ED threshold");
-        ScheduleTest(delay,
-                     {{-57.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{40},
-                       MHz_u{80}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {});
-        delay += Seconds(1.0);
+        ScheduleTest(
+            delay,
+            "Reception of a 80 MHz signal that occupies the first four subchannels of "
+            "S160 below ED threshold",
+            {{dBm_u{-57}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{40}, MHz_u{80}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {});
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
         // occupies the first four 20 MHz subchannels of the S160 with received power above the
         // energy detection threshold for any occupied 20 MHz subchannels
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 80 MHz signal that occupies the first four "
-                            "subchannels of S160 above ED threshold");
-        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 8, 4, MicroSeconds(100));
-        ScheduleTest(delay,
-                     {{-55.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY - MHz_u{40},
-                       MHz_u{80}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {{MicroSeconds(100) - smallDelta,
-                       MicroSeconds(100),
-                       WIFI_CHANLIST_SECONDARY160,
-                       m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 8, 4, txDuration1);
+        ScheduleTest(
+            delay,
+            "Reception of a 80 MHz signal that occupies the first four subchannels of "
+            "S160 above ED threshold",
+            {{dBm_u{-55}, tx1Start, txDuration1, S160_CENTER_FREQUENCY - MHz_u{40}, MHz_u{80}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
+              WIFI_CHANLIST_SECONDARY160,
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
         // occupies the last four 20 MHz subchannels of the S160 with received power below the
         // energy detection threshold for all occupied 20 MHz subchannels
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 80 MHz signal that occupies the last four "
-                            "subchannels of S160 below ED threshold");
-        ScheduleTest(delay,
-                     {{-57.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY + MHz_u{40},
-                       MHz_u{80}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {});
-        delay += Seconds(1.0);
+        ScheduleTest(
+            delay,
+            "Reception of a 80 MHz signal that occupies the last four subchannels of S160 "
+            "below ED threshold",
+            {{dBm_u{-57}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{40}, MHz_u{80}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {});
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
         // occupies the last four 20 MHz subchannels of the S160 with received power above the
         // energy detection threshold for any occupied 20 MHz subchannels
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 80 MHz signal that occupies the last four "
-                            "subchannels of S160 above ED threshold");
-        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 12, 4, MicroSeconds(100));
-        ScheduleTest(delay,
-                     {{-55.0,
-                       MicroSeconds(0),
-                       MicroSeconds(100),
-                       S160_CENTER_FREQUENCY + MHz_u{40},
-                       MHz_u{80}}},
-                     {},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {MicroSeconds(100) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {MicroSeconds(100) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {{MicroSeconds(100) - smallDelta,
-                       MicroSeconds(100),
-                       WIFI_CHANLIST_SECONDARY160,
-                       m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 12, 4, txDuration1);
+        ScheduleTest(
+            delay,
+            "Reception of a 80 MHz signal that occupies the last four subchannels of S160 "
+            "above ED threshold",
+            {{dBm_u{-55}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{40}, MHz_u{80}}},
+            {},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {txEndSignal1 - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {txEndSignal1 + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
+              WIFI_CHANLIST_SECONDARY160,
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
-        // occupies the whole S160 with received power below the energy detection threshold for
-        // all occupied 20 MHz subchannels
-        Simulator::Schedule(
-            delay,
-            &WifiPhyCcaIndicationTest::LogScenario,
-            this,
-            "Reception of a 160 MHz signal that occupies the whole S160 below ED threshold");
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal occupies
+        // the whole S160 with received power below the energy detection threshold for all occupied
+        // 20 MHz subchannels
         ScheduleTest(
             delay,
-            {{-54.0, MicroSeconds(0), MicroSeconds(100), S160_CENTER_FREQUENCY, MHz_u{160}}},
+            "Reception of a 160 MHz signal that occupies the whole S160 below ED threshold",
+            {{dBm_u{-54}, tx1Start, txDuration1, S160_CENTER_FREQUENCY, MHz_u{160}}},
             {},
             {
                 {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                {MicroSeconds(100) - smallDelta,
+                {txEndSignal1 - smallDelta,
                  WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                {MicroSeconds(100) + smallDelta,
+                {txEndSignal1 + smallDelta,
                  WifiPhyState::IDLE} // IDLE just after the transmission ends
             },
             {});
-        delay += Seconds(1.0);
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
-        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal
-        // occupies the whole S160 with received power above the energy detection threshold for
-        // any occupied 20 MHz subchannels
-        Simulator::Schedule(
-            delay,
-            &WifiPhyCcaIndicationTest::LogScenario,
-            this,
-            "Reception of a 160 MHz signal that occupies the whole S160 above ED threshold");
-        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 8, 8, MicroSeconds(100));
+        // Verify PHY state stays IDLE and no CCA-BUSY indication is reported if a signal occupies
+        // the whole S160 with received power above the energy detection threshold for any occupied
+        // 20 MHz subchannels
+        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 8, 8, txDuration1);
         ScheduleTest(
             delay,
-            {{-52.0, MicroSeconds(0), MicroSeconds(100), S160_CENTER_FREQUENCY, MHz_u{160}}},
+            "Reception of a 160 MHz signal that occupies the whole S160 above ED threshold",
+            {{dBm_u{-52}, tx1Start, txDuration1, S160_CENTER_FREQUENCY, MHz_u{160}}},
             {},
             {
                 {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                {MicroSeconds(100) - smallDelta,
+                {txEndSignal1 - smallDelta,
                  WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                {MicroSeconds(100) + smallDelta,
+                {txEndSignal1 + smallDelta,
                  WifiPhyState::IDLE} // IDLE just after the transmission ends
             },
-            {{MicroSeconds(100) - smallDelta,
-              MicroSeconds(100),
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
               WIFI_CHANLIST_SECONDARY160,
               m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE as long as a 320 MHz signal below the energy detection
         // threshold occupies the whole band
-        Simulator::Schedule(
-            delay,
-            &WifiPhyCcaIndicationTest::LogScenario,
-            this,
-            "Reception of a 320 MHz signal that occupies the whole band below ED threshold");
         ScheduleTest(
             delay,
-            {{-51.0, MicroSeconds(0), MicroSeconds(100), P320_CENTER_FREQUENCY, MHz_u{320}}},
+            "Reception of a 320 MHz signal that occupies the whole band below ED threshold",
+            {{dBm_u{-51}, tx1Start, txDuration1, P320_CENTER_FREQUENCY, MHz_u{320}}},
             {},
             {
                 {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                {MicroSeconds(100) - smallDelta,
+                {txEndSignal1 - smallDelta,
                  WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                {MicroSeconds(100) + smallDelta,
+                {txEndSignal1 + smallDelta,
                  WifiPhyState::IDLE} // IDLE just after the transmission ends
             },
             {});
-
-        delay += Seconds(1.0);
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state is CCA-BUSY as long as a 320 MHz signal above the energy detection
         // threshold occupies the whole band
-        Simulator::Schedule(
-            delay,
-            &WifiPhyCcaIndicationTest::LogScenario,
-            this,
-            "Reception of a 320 MHz signal that occupies the whole band above ED threshold");
-        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin(), 16, MicroSeconds(100));
+        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin(), 16, txDuration1);
         ScheduleTest(
             delay,
-            {{-49.0, MicroSeconds(0), MicroSeconds(100), P320_CENTER_FREQUENCY, MHz_u{320}}},
+            "Reception of a 320 MHz signal that occupies the whole band above ED threshold",
+            {{dBm_u{-49}, tx1Start, txDuration1, P320_CENTER_FREQUENCY, MHz_u{320}}},
             {},
             {
                 {aCcaTimeWithDelta, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCcaTimeWithDelta
-                {MicroSeconds(100) - smallDelta,
+                {txEndSignal1 - smallDelta,
                  WifiPhyState::CCA_BUSY}, // CCA-BUSY just before the transmission ends
-                {MicroSeconds(100) + smallDelta,
+                {txEndSignal1 + smallDelta,
                  WifiPhyState::IDLE} // IDLE just after the transmission ends
             },
-            {{MicroSeconds(100) - smallDelta,
-              MicroSeconds(100),
+            {{txEndSignal1 - smallDelta,
+              1,
+              tx1Start,
+              txEndSignal1,
               WIFI_CHANLIST_PRIMARY,
               m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY notifies CCA-BUSY for the P20 channel while the S160 channel was already
         // in CCA-BUSY state
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a 20 MHz signal that occupies S160 followed by the "
-                            "reception of another 20 MHz signal that occupies P20");
-        m_expectedPer20MhzCcaBusyDurations.at(0).at(15) = MicroSeconds(100);
-        m_expectedPer20MhzCcaBusyDurations.at(1).at(0) = MicroSeconds(100);
-        m_expectedPer20MhzCcaBusyDurations.at(1).at(15) = MicroSeconds(50);
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(15) = txDuration1;
+        m_expectedPer20MhzCcaBusyDurations.at(1).at(0) = txDuration2;
+        m_expectedPer20MhzCcaBusyDurations.at(1).at(15) = txDiff;
         ScheduleTest(
             delay,
-            {{-52.0,
-              MicroSeconds(0),
-              MicroSeconds(100),
-              S160_CENTER_FREQUENCY + MHz_u{70},
-              MHz_u{20}},
-             {-52.0, MicroSeconds(50), MicroSeconds(100), P20_CENTER_FREQUENCY, MHz_u{20}}},
+            "Reception of a 20 MHz signal that occupies S160 followed by the reception of another "
+            "20 MHz signal that occupies P20",
+            {{dBm_u{-52}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{70}, MHz_u{20}},
+             {dBm_u{-52}, tx2Start, txDuration2, P20_CENTER_FREQUENCY, MHz_u{20}}},
             {},
             {
                 {aCcaTimeWithDelta,
                  WifiPhyState::IDLE}, // state of primary stays idle after aCcaTimeWithDelta
-                {MicroSeconds(50) + aCcaTimeWithDelta,
+                {tx2Start + aCcaTimeWithDelta,
                  WifiPhyState::CCA_BUSY}, // state of primary is CCA-BUSY after
                                           // aCcaTimeWithDelta that followed the second
                                           // transmission
-                {MicroSeconds(50) + MicroSeconds(100) - smallDelta,
+                {txEndSignal2 - smallDelta,
                  WifiPhyState::CCA_BUSY}, // CCA-BUSY just before the transmission ends
-                {MicroSeconds(50) + MicroSeconds(100) + smallDelta,
+                {txEndSignal2 + smallDelta,
                  WifiPhyState::IDLE} // IDLE just after the transmission ends
             },
             {{aCcaTimeWithDelta, // notification upon reception of the first signal
-              MicroSeconds(100),
+              1,
+              tx1Start,
+              txEndSignal1,
               WIFI_CHANLIST_SECONDARY160,
               m_expectedPer20MhzCcaBusyDurations.at(0)},
-             {MicroSeconds(50) +
-                  aCcaTimeWithDelta, // notification upon reception of the second signal
-              MicroSeconds(50) + MicroSeconds(100),
+             {tx2Start + aCcaTimeWithDelta, // notification upon reception of the second signal
+              2,
+              tx1Start,
+              txEndSignal2,
               WIFI_CHANLIST_PRIMARY,
               m_expectedPer20MhzCcaBusyDurations.at(1)}});
-        delay += Seconds(1.0);
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE but notifies CCA-BUSY for the S80 channel while the S160
         // channel was already in CCA-BUSY state
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a signal that occupies S160 followed by the reception of "
-                            "another signal that occupies S80");
-        m_expectedPer20MhzCcaBusyDurations.at(0).at(14) = MicroSeconds(100);
-        m_expectedPer20MhzCcaBusyDurations.at(1).at(5) = MicroSeconds(100);
-        m_expectedPer20MhzCcaBusyDurations.at(1).at(14) = MicroSeconds(50);
-        ScheduleTest(
-            delay,
-            {{-52.0,
-              MicroSeconds(0),
-              MicroSeconds(100),
-              S160_CENTER_FREQUENCY + MHz_u{50},
-              MHz_u{20}},
-             {-52.0,
-              MicroSeconds(50),
-              MicroSeconds(100),
-              S80_CENTER_FREQUENCY - MHz_u{10},
-              MHz_u{20}}},
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(14) = txDuration1;
+        m_expectedPer20MhzCcaBusyDurations.at(1).at(5) = txDuration2;
+        m_expectedPer20MhzCcaBusyDurations.at(1).at(14) = txDiff;
+        ScheduleTest(
+            delay,
+            "Reception of a signal that occupies S160 followed by the reception of another signal "
+            "that occupies S80",
+            {{dBm_u{-52}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{50}, MHz_u{20}},
+             {dBm_u{-52}, tx2Start, txDuration2, S80_CENTER_FREQUENCY - MHz_u{10}, MHz_u{20}}},
             {},
             {
                 {aCcaTimeWithDelta,
                  WifiPhyState::IDLE}, // state of primary stays idle after aCcaTimeWithDelta
-                {MicroSeconds(50) + aCcaTimeWithDelta,
-                 WifiPhyState::IDLE}, // state of primary stays IDLE
-                {MicroSeconds(50) + MicroSeconds(100) - smallDelta,
+                {tx2Start + aCcaTimeWithDelta, WifiPhyState::IDLE}, // state of primary stays IDLE
+                {txEndSignal2 - smallDelta,
                  WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                {MicroSeconds(50) + MicroSeconds(100) + smallDelta,
+                {txEndSignal2 + smallDelta,
                  WifiPhyState::IDLE} // IDLE just after the transmission ends
             },
             {{aCcaTimeWithDelta, // notification upon reception of the first signal
-              MicroSeconds(100),
+              1,
+              tx1Start,
+              txEndSignal1,
               WIFI_CHANLIST_SECONDARY160,
               m_expectedPer20MhzCcaBusyDurations.at(0)},
-             {MicroSeconds(50) +
-                  aCcaTimeWithDelta, // notification upon reception of the second signal
-              MicroSeconds(50) + MicroSeconds(100),
+             {tx2Start + aCcaTimeWithDelta, // notification upon reception of the second signal
+              2,
+              tx1Start,
+              txEndSignal2,
               WIFI_CHANLIST_SECONDARY80,
               m_expectedPer20MhzCcaBusyDurations.at(1)}});
-        delay += Seconds(1.0);
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE but notifies CCA-BUSY for the S40 channel while the S160
         // channel was already in CCA-BUSY state
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a signal that occupies S160 followed by the reception of "
-                            "another signal that occupies S40");
-        m_expectedPer20MhzCcaBusyDurations.at(0).at(13) = MicroSeconds(100);
-        m_expectedPer20MhzCcaBusyDurations.at(1).at(3) = MicroSeconds(100);
-        m_expectedPer20MhzCcaBusyDurations.at(1).at(13) = MicroSeconds(50);
-        ScheduleTest(
-            delay,
-            {{-52.0,
-              MicroSeconds(0),
-              MicroSeconds(100),
-              S160_CENTER_FREQUENCY + MHz_u{30},
-              MHz_u{20}},
-             {-52.0,
-              MicroSeconds(50),
-              MicroSeconds(100),
-              S40_CENTER_FREQUENCY + MHz_u{10},
-              MHz_u{20}}},
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(13) = txDuration1;
+        m_expectedPer20MhzCcaBusyDurations.at(1).at(3) = txDuration2;
+        m_expectedPer20MhzCcaBusyDurations.at(1).at(13) = txDiff;
+        ScheduleTest(
+            delay,
+            "Reception of a signal that occupies S160 followed by the reception of another signal "
+            "that occupies S40",
+            {{dBm_u{-52}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{30}, MHz_u{20}},
+             {dBm_u{-52}, tx2Start, txDuration2, S40_CENTER_FREQUENCY + MHz_u{10}, MHz_u{20}}},
             {},
             {
                 {aCcaTimeWithDelta,
                  WifiPhyState::IDLE}, // state of primary stays idle after aCcaTimeWithDelta
-                {MicroSeconds(50) + aCcaTimeWithDelta,
-                 WifiPhyState::IDLE}, // state of primary stays IDLE
-                {MicroSeconds(50) + MicroSeconds(100) - smallDelta,
+                {tx2Start + aCcaTimeWithDelta, WifiPhyState::IDLE}, // state of primary stays IDLE
+                {txEndSignal2 - smallDelta,
                  WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                {MicroSeconds(50) + MicroSeconds(100) + smallDelta,
+                {txEndSignal2 + smallDelta,
                  WifiPhyState::IDLE} // IDLE just after the transmission ends
             },
             {{aCcaTimeWithDelta, // notification upon reception of the first signal
-              MicroSeconds(100),
+              1,
+              tx1Start,
+              txEndSignal1,
               WIFI_CHANLIST_SECONDARY160,
               m_expectedPer20MhzCcaBusyDurations.at(0)},
-             {MicroSeconds(50) +
-                  aCcaTimeWithDelta, // notification upon reception of the second signal
-              MicroSeconds(50) + MicroSeconds(100),
+             {tx2Start + aCcaTimeWithDelta, // notification upon reception of the second signal
+              2,
+              tx1Start,
+              txEndSignal2,
               WIFI_CHANLIST_SECONDARY40,
               m_expectedPer20MhzCcaBusyDurations.at(1)}});
-        delay += Seconds(1.0);
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE but notifies CCA-BUSY for the S20 channel while the S160
         // channel was already in CCA-BUSY state
-        Simulator::Schedule(delay,
-                            &WifiPhyCcaIndicationTest::LogScenario,
-                            this,
-                            "Reception of a signal that occupies S160 followed by the reception of "
-                            "another signal that occupies S20");
-        m_expectedPer20MhzCcaBusyDurations.at(0).at(12) = MicroSeconds(100);
-        m_expectedPer20MhzCcaBusyDurations.at(1).at(1) = MicroSeconds(100);
-        m_expectedPer20MhzCcaBusyDurations.at(1).at(12) = MicroSeconds(50);
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(12) = txDuration1;
+        m_expectedPer20MhzCcaBusyDurations.at(1).at(1) = txDuration2;
+        m_expectedPer20MhzCcaBusyDurations.at(1).at(12) = txDiff;
         ScheduleTest(
             delay,
-            {{-52.0,
-              MicroSeconds(0),
-              MicroSeconds(100),
-              S160_CENTER_FREQUENCY + MHz_u{10},
-              MHz_u{20}},
-             {-52.0, MicroSeconds(50), MicroSeconds(100), S20_CENTER_FREQUENCY, MHz_u{20}}},
+            "Reception of a signal that occupies S160 followed by the reception of another signal "
+            "that occupies S20",
+            {{dBm_u{-52}, tx1Start, txDuration1, S160_CENTER_FREQUENCY + MHz_u{10}, MHz_u{20}},
+             {dBm_u{-52}, tx2Start, txDuration2, S20_CENTER_FREQUENCY, MHz_u{20}}},
             {},
             {
                 {aCcaTimeWithDelta,
                  WifiPhyState::IDLE}, // state of primary stays idle after aCcaTimeWithDelta
-                {MicroSeconds(50) + aCcaTimeWithDelta,
-                 WifiPhyState::IDLE}, // state of primary stays IDLE
-                {MicroSeconds(50) + MicroSeconds(100) - smallDelta,
+                {tx2Start + aCcaTimeWithDelta, WifiPhyState::IDLE}, // state of primary stays IDLE
+                {txEndSignal2 - smallDelta,
                  WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                {MicroSeconds(50) + MicroSeconds(100) + smallDelta,
+                {txEndSignal2 + smallDelta,
                  WifiPhyState::IDLE} // IDLE just after the transmission ends
             },
             {{aCcaTimeWithDelta, // notification upon reception of the first signal
-              MicroSeconds(100),
+              1,
+              tx1Start,
+              txEndSignal1,
               WIFI_CHANLIST_SECONDARY160,
               m_expectedPer20MhzCcaBusyDurations.at(0)},
-             {MicroSeconds(50) +
-                  aCcaTimeWithDelta, // notification upon reception of the second signal
-              MicroSeconds(50) + MicroSeconds(100),
+             {tx2Start + aCcaTimeWithDelta, // notification upon reception of the second signal
+              2,
+              tx1Start,
+              txEndSignal2,
               WIFI_CHANLIST_SECONDARY,
               m_expectedPer20MhzCcaBusyDurations.at(1)}});
-        delay += Seconds(1.0);
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE when a 160 MHz PPDU that occupies S160 with received
         // power below the Per 20 MHz CCA threshold for all occupied 20 MHz subchannels
-        Simulator::Schedule(
+        ScheduleTest(
             delay,
-            &WifiPhyCcaIndicationTest::LogScenario,
-            this,
-            "Reception of a 160 MHz PPDU that occupies S160 below CCA sensitivity threshold");
-        ScheduleTest(delay,
-                     {},
-                     {{-64.0, MicroSeconds(0), S160_CENTER_FREQUENCY, MHz_u{160}}},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {ppduDurations.at(160) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {ppduDurations.at(160) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {});
-        delay += Seconds(1.0);
+            "Reception of a 160 MHz PPDU that occupies S160 below CCA sensitivity threshold",
+            {},
+            {{dBm_u{-64}, tx1Start, S160_CENTER_FREQUENCY, MHz_u{160}}},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {ppduDurations.at(MHz_u{160}) - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {ppduDurations.at(MHz_u{160}) + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {});
+        delay += testStep;
 
         //----------------------------------------------------------------------------------------------------------------------------------
         // Verify PHY state stays IDLE but CCA-BUSY indication is reported when a 160 MHz PPDU
         // that occupies S160 with received power above the Per 20 MHz CCA threshold for any
         // occupied 20 MHz subchannels
-        Simulator::Schedule(
+        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 8,
+                    8,
+                    ppduDurations.at(MHz_u{160}));
+        ScheduleTest(
             delay,
-            &WifiPhyCcaIndicationTest::LogScenario,
-            this,
-            "Reception of a 160 MHz PPDU that occupies S160 above CCA sensitivity threshold");
-        std::fill_n(m_expectedPer20MhzCcaBusyDurations.at(0).begin() + 8, 8, ppduDurations.at(160));
-        ScheduleTest(delay,
-                     {},
-                     {{-62.0, MicroSeconds(0), S160_CENTER_FREQUENCY, MHz_u{160}}},
-                     {
-                         {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
-                         {ppduDurations.at(160) - smallDelta,
-                          WifiPhyState::IDLE}, // IDLE just before the transmission ends
-                         {ppduDurations.at(160) + smallDelta,
-                          WifiPhyState::IDLE} // IDLE just after the transmission ends
-                     },
-                     {{aCcaTimeWithDelta,
-                       ppduDurations.at(160),
-                       WIFI_CHANLIST_SECONDARY160,
-                       m_expectedPer20MhzCcaBusyDurations.at(0)}});
-        delay += Seconds(1.0);
+            "Reception of a 160 MHz PPDU that occupies S160 above CCA sensitivity threshold",
+            {},
+            {{dBm_u{-62}, tx1Start, S160_CENTER_FREQUENCY, MHz_u{160}}},
+            {
+                {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+                {ppduDurations.at(MHz_u{160}) - smallDelta,
+                 WifiPhyState::IDLE}, // IDLE just before the transmission ends
+                {ppduDurations.at(MHz_u{160}) + smallDelta,
+                 WifiPhyState::IDLE} // IDLE just after the transmission ends
+            },
+            {{aCcaTimeWithDelta,
+              1,
+              tx1Start,
+              ppduDurations.at(MHz_u{160}),
+              WIFI_CHANLIST_SECONDARY160,
+              m_expectedPer20MhzCcaBusyDurations.at(0)}});
+        delay += testStep;
         ResetExpectedPer20MhzCcaBusyDurations();
     }
 
+    if (m_channelWidth > MHz_u{20})
+    {
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(0) = txDuration1;
+        m_expectedPer20MhzCcaBusyDurations.at(1).at(0) = Time();
+    }
+
+    ScheduleTest(
+        delay,
+        "Reception of signal above ED threshold that triggers CCA BUSY indication followed by CCA "
+        "IDLE indication when the threshold is increased",
+        {{dBm_u{-60}, tx1Start, txDuration1, P20_CENTER_FREQUENCY, MHz_u{20}}},
+        {},
+        {
+            {aCcaTimeWithDelta, WifiPhyState::CCA_BUSY}, // CCA-BUSY after aCcaTimeWithDelta
+            {thresholdUpdateTime - smallDelta,
+             WifiPhyState::CCA_BUSY}, // CCA-BUSY just before the threshold changes
+            {thresholdUpdateTime + smallDelta,
+             WifiPhyState::IDLE}, // IDLE just after the threshold changes
+            {txEndSignal1 - smallDelta,
+             WifiPhyState::IDLE}, // IDLE just before the transmission ends
+            {txEndSignal1 + smallDelta, WifiPhyState::IDLE} // IDLE just after the transmission ends
+        },
+        {{thresholdUpdateTime - smallDelta,
+          1, // first notification CCA busy until end of transmission
+          tx1Start,
+          txEndSignal1,
+          WIFI_CHANLIST_PRIMARY,
+          m_expectedPer20MhzCcaBusyDurations.at(0)},
+         {txEndSignal1 - smallDelta,
+          2, // second notification CCA busy ends when threshold changed
+          tx1Start,
+          thresholdUpdateTime,
+          WIFI_CHANLIST_PRIMARY,
+          m_expectedPer20MhzCcaBusyDurations.at(1)}},
+        {
+            {.timePoint = thresholdUpdateTime,
+             .ccaThreshold =
+                 dBm_u{-50}}, // change CCA threshold during the reception to a higher value
+        });
+    delay += testStep;
+    ResetExpectedPer20MhzCcaBusyDurations();
+
+    if (m_channelWidth > MHz_u{20})
+    {
+        m_expectedPer20MhzCcaBusyDurations.at(0).at(0) = txDuration1 - thresholdUpdateTime;
+    }
+
+    ScheduleTest(
+        delay,
+        "Reception of signal below ED threshold that triggers CCA IDLE indication followed by CCA "
+        "BUSY indication when the threshold is decreased",
+        {{dBm_u{-65}, tx1Start, txDuration1, P20_CENTER_FREQUENCY, MHz_u{20}}},
+        {},
+        {
+            {aCcaTimeWithDelta, WifiPhyState::IDLE}, // IDLE after aCcaTimeWithDelta
+            {thresholdUpdateTime - smallDelta,
+             WifiPhyState::IDLE}, // IDLE just before the threshold changes
+            {thresholdUpdateTime + smallDelta,
+             WifiPhyState::CCA_BUSY}, // CCA-BUSY just after the threshold changes
+            {txEndSignal1 - smallDelta,
+             WifiPhyState::CCA_BUSY}, // CCA-BUSY just before the transmission ends
+            {txEndSignal1 + smallDelta, WifiPhyState::IDLE} // IDLE just after the transmission ends
+        },
+        {
+            {txEndSignal1 - smallDelta,
+             1, // first notification CCA busy until end of transmission since threshold changed
+             thresholdUpdateTime,
+             txEndSignal1,
+             WIFI_CHANLIST_PRIMARY,
+             m_expectedPer20MhzCcaBusyDurations.at(0)},
+        },
+        {
+            {.timePoint = thresholdUpdateTime,
+             .ccaThreshold =
+                 dBm_u{-70}}, // change CCA threshold during the reception to a higher value
+        });
+    delay += testStep;
+    ResetExpectedPer20MhzCcaBusyDurations();
+
     Simulator::Run();
 }
 
